# -*- coding: utf-8 -*-
# ---------------------------------------------------------------------------
# corona-preview-process.py
# Скачать и привязать все превью CORONA
# Author: Maxim Dubinin (sim@gis-lab.info)
# Date: 17:26 06.01.2013
# ---------------------------------------------------------------------------
import os
import urllib2
import osgeo.gdal as gdal

def download(url,file_name):
    #download mp3

    if os.path.isfile(file_name) == False:
        
        u = urllib2.urlopen(url)
        meta = u.info()
        meta_len = len(meta.getheaders("Content-Length"))
        
        f = open(file_name, 'wb')
        
        file_size = int(meta.getheaders("Content-Length")[0])
        print "Downloading: %s Bytes: %s" % (file_name, file_size)

        file_size_dl = 0
        block_sz = 8192
        while True:
            buffer = u.read(block_sz)
            if not buffer:
                break

            file_size_dl += len(buffer)
            f.write(buffer)
            status = r"%10d  [%3.2f%%]" % (file_size_dl, file_size_dl * 100. / file_size)
            status = status + chr(8)*(len(status)+1)
            print status,

        f.close()

def dms_deg(val):
    #beautiful replacement for function below from DR (not used out of envy :): 
    #s=u'''42°57'00.00"N'''
    #d,m,s,s_,p = tuple(re.findall(r'\w+', s))
    #result = (int(d)+int(m)/60.+(int(s)+int(s_)/100.)/3600)*{u'W':-1,u'S':-1,u'N':1,u'E':1}.get(p)
    
    dd = int(val.split('\xb0')[0]) #dd = int(val.split('°')[0])
    mm = int(val.split('\xb0')[1].split("'")[0])
    ss = float(val.split('\xb0')[1].split("'")[1].split('"')[0])
    sign_letter = val.split('\xb0')[1].split("'")[1].split('"')[1]
    if sign_letter == 'S' or sign_letter == 'W':
        sign = -1
    else:
        sign = 1
    
    res = (dd + mm/60. + ss/3600.)*sign
    
    return res

def georef(file_name):
    fnoutn = file_name.replace("jpg","tif")
    gdalData = gdal.Open( file_name )
    if gdalData is not None:
        x = str(gdalData.RasterXSize)
        y = str(gdalData.RasterYSize)
        cmd = "gdal_translate -a_srs \"EPSG:4326\" -of GTiff -gcp 0 0 " + str(nw_lon) + " " + str(nw_lat) +"  -gcp " + x +" 0 " + str(ne_lon) + " " + str(ne_lat) + " -gcp 0 " + y + " " + str(sw_lon) + " " + str(sw_lat) + " -gcp " + x + " " + y + " " + str(se_lon) + " " + str(se_lat) + " " + file_name + " temp.tif"
        os.system(cmd)
        
        if not os.path.exists("georef"): os.makedirs("georef")
        cmd = "gdalwarp -dstnodata 0 temp.tif georef/" + fnoutn
        os.system(cmd)
        
        os.system("del temp.tif")
    else:
        errf.write(file_name+"\n")

#constants
urlpref = 'http://earthexplorer.usgs.gov/browse/DIT/'
fin  = "list-full.csv"

fi = open(fin)
recs = fi.readlines()
del recs[0]
errorsfile="errors.log"
errf = open(errorsfile,'w')

for rec in recs:
    recl = rec.split(",")
    #example DS009013038DV130
    id = recl[1]
    mission = id[2:8].lstrip('0')
    revol = id[8:12]
    camera = id[12]
    
    fn = id + ".jpg"
    fnfull = urlpref + mission + "/" + revol + "/" + camera + "/" + fn
    download(fnfull,fn)
    nw_lat = recl[6].split(" ")[0]
    nw_lon = recl[6].split(" ")[2]
    nw_lat = dms_deg(nw_lat)
    nw_lon = dms_deg(nw_lon)
    ne_lat = recl[7].split(" ")[0]
    ne_lon = recl[7].split(" ")[2]
    ne_lat = dms_deg(ne_lat)
    ne_lon = dms_deg(ne_lon)
    sw_lat = recl[8].split(" ")[0]
    sw_lon = recl[8].split(" ")[2]
    sw_lat = dms_deg(sw_lat)
    sw_lon = dms_deg(sw_lon)
    se_lat = recl[9].split(" ")[0]
    se_lon = recl[9].split(" ")[2]
    se_lat = dms_deg(se_lat)
    se_lon = dms_deg(se_lon)
    
    georef(fn)